=== debian/changelog ===
mtail (3.0.0~rc35-3) unstable; urgency=medium

  * Team upload.
  * Add .service file (Closes: #886894)

 -- Antoine Beaupré <anarcat@debian.org>  Fri, 24 Apr 2020 16:22:36 -0400

mtail (3.0.0~rc35-2) unstable; urgency=medium

  * Team upload.
  * Ignore known test failure on 32-bit architectures, reported upstream
    as https://github.com/google/mtail/issues/313

 -- Antoine Beaupré <anarcat@debian.org>  Thu, 23 Apr 2020 17:21:10 -0400

mtail (3.0.0~rc35-1) unstable; urgency=medium

  * Team upload.
  * New upstream release, with jaeger support patched out because missing
    from Debian (Closes: #958417)
  * fix test suite (Closes: #952333)

 -- Antoine Beaupré <anarcat@debian.org>  Tue, 21 Apr 2020 15:09:07 -0400
