## mtail 3.0.0~rc38

=== Makefile ===
--- 
+++ 
@@ -28,13 +28,7 @@
 
 # Set the timeout for tests run under the race detector.
 timeout := 10m
-ifeq ($(TRAVIS),true)
-timeout := 20m
-endif
-ifeq ($(CIRCLECI),true)
-timeout := 20m
-endif
-ifeq ($(CIRRUS_CI),true)
+ifeq ($(CI),true)
 timeout := 20m
 endif
 # Let the benchmarks run for a long time.  The timeout is for the total time of
@@ -72,9 +66,9 @@
 $(GOYACC):
 	go get $(GOGETFLAGS) golang.org/x/tools/cmd/goyacc
 
-GOFUZZBUILD = $(GOBIN)/go-fuzz-build
+GOFUZZBUILD = $(GOBIN)/go114-fuzz-build
 $(GOFUZZBUILD):
-	go get $(GOGETFLAGS) github.com/dvyukov/go-fuzz/go-fuzz-build
+	go get $(GOGETFLAGS) github.com/mdempsky/go114-fuzz-build
 
 GOFUZZ = $(GOBIN)/go-fuzz
 $(GOFUZZ):
@@ -115,12 +109,14 @@
 GO_LDFLAGS := -X main.Branch=${branch} -X main.Version=${version} -X main.Revision=${revision}
 
 ifeq ($(STATIC),y)
-	# -s Omit symbol table and debug info
-	# -w Omit DWARF symbol table
-	# -extldflags -static and CGO_ENABLED=0 to make pure static
-	GO_LDFLAGS += -w -s -extldflags "-static"
-	export CGO_ENABLED=0
+# -s Omit symbol table and debug info
+# -w Omit DWARF symbol table
+# -extldflags -static and CGO_ENABLED=0 to make pure static
+GO_LDFLAGS += -w -s -extldflags "-static"
+export CGO_ENABLED=0
 endif
+
+GO_GCFLAGS = -e
 
 # Very specific static pattern rule to only do this for commandline targets.
 # Each commandline must be in a 'main.go' in their respective directory.  The
@@ -129,7 +125,7 @@
 # runs can read the dependencies and update iff they change.
 $(TARGETS): %: cmd/%/main.go $(DEPDIR)/%.d | print-version .dep-stamp
 	$(MAKEDEPEND)
-	go build -ldflags "$(GO_LDFLAGS)" -o $@ $<
+	go build -gcflags "$(GO_GCFLAGS)" -ldflags "$(GO_LDFLAGS)" -o $@ $<
 
 internal/vm/parser/parser.go: internal/vm/parser/parser.y | $(GOYACC)
 	go generate -x ./$(@D)
@@ -162,7 +158,7 @@
 	install -m 755 $< $@
 
 
-GOX_OSARCH ?= "linux/amd64 windows/amd64 darwin/amd64"
+GOX_OSARCH ?= "linux/amd64 windows/amd64 darwin/amd64 linux/arm linux/arm64 linux/ppc64"
 #GOX_OSARCH := ""
 
 .PHONY: crossbuild
@@ -172,26 +168,26 @@
 
 .PHONY: test check
 check test: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
-	go test -timeout 10s ./...
+	go test -gcflags "$(GO_GCFLAGS)" -timeout 10s ./...
 
 .PHONY: testrace
 testrace: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
-	go test -timeout ${timeout} -race -v -tags=integration ./...
+	go test -gcflags "$(GO_GCFLAGS)" -timeout ${timeout} -race -v ./...
 
 .PHONY: smoke
 smoke: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
-	go test -timeout 1s -test.short ./...
+	go test -gcflags "$(GO_GCFLAGS)" -timeout 1s -test.short ./...
 
 .PHONY: bench
 bench: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
-	go test -tags=integration -bench=. -timeout=${benchtimeout} -benchtime=5s -run=BenchmarkProgram ./...
+	go test -gcflags "$(GO_GCFLAGS)" -bench=. -timeout=${benchtimeout} -benchtime=5s -run=BenchmarkProgram ./...
 
 .PHONY: bench_cpu
 bench_cpu: | print-version .dep-stamp
-	go test -tags=integration -bench=. -run=BenchmarkProgram -timeout=${benchtimeout} -benchtime=5s -cpuprofile=cpu.out internal/mtail/examples_integration_test.go
+	go test -bench=. -run=BenchmarkProgram -timeout=${benchtimeout} -benchtime=5s -cpuprofile=cpu.out internal/mtail/examples_integration_test.go
 .PHONY: bench_mem
 bench_mem: | print-version .dep-stamp
-	go test -tags=integration -bench=. -run=BenchmarkProgram -timeout=${benchtimeout} -benchtime=5s -memprofile=mem.out internal/mtail/examples_integration_test.go
+	go test -bench=. -run=BenchmarkProgram -timeout=${benchtimeout} -benchtime=5s -memprofile=mem.out internal/mtail/examples_integration_test.go
 
 .PHONY: recbench
 recbench: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
@@ -199,7 +195,7 @@
 
 .PHONY: regtest
 regtest: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
-	go test -v -tags=integration -timeout=${timeout} ./...
+	go test -gcflags "$(GO_GCFLAGS)" -v -timeout=${timeout} ./...
 
 TESTRESULTS ?= test-results
 TESTCOVERPROFILE ?= out.coverprofile
@@ -208,7 +204,7 @@
 junit-regtest: $(TESTRESULTS)/test-output.xml $(TESTCOVERPROFILE)
 $(TESTRESULTS)/test-output.xml $(TESTCOVERPROFILE): $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp $(GOTESTSUM)
 	mkdir -p $(TESTRESULTS)
-	$(GOTESTSUM) --junitfile $(TESTRESULTS)/test-output.xml -- -race -coverprofile=$(TESTCOVERPROFILE) --covermode=atomic -tags=integration -v -timeout=${timeout} ./...
+	$(GOTESTSUM) --junitfile $(TESTRESULTS)/test-output.xml -- -race -parallel 1 -coverprofile=$(TESTCOVERPROFILE) --covermode=atomic -v -timeout=${timeout} -gcflags "$(GO_GCFLAGS)" ./...
 
 PACKAGES := $(shell go list -f '{{.Dir}}' ./... | grep -v /vendor/ | grep -v /cmd/ | sed -e "s@$$(pwd)@.@")
 
@@ -239,11 +235,11 @@
 # These flags set compatibility with OSS-Fuzz
 CXX ?= clang-9
 CXXFLAGS ?=
-LIB_FUZZING_ENGINE ?= -libfuzzer
+LIB_FUZZING_ENGINE ?= -fsanitize=fuzzer
 OUT ?= .
 
 $(OUT)/vm-fuzzer: $(GOFILES) | $(GOFUZZBUILD)
-	$(GOFUZZBUILD) -libfuzzer -o fuzzer.a ./internal/vm
+	$(GOFUZZBUILD) -o fuzzer.a ./internal/vm
 	$(CXX) $(CXXFLAGS) $(LIB_FUZZING_ENGINE) fuzzer.a -lpthread -o $(OUT)/vm-fuzzer
 
 $(OUT)/vm-fuzzer.dict: mgen
@@ -252,7 +248,7 @@
 $(OUT)/vm-fuzzer_seed_corpus.zip: $(wildcard examples/*.mtail) $(wildcard internal/vm/fuzz/*.mtail)
 	zip -j $@ $^
 
-.INTERMEDIATE: SEED
+.INTERMEDIATE: SEED/*
 SEED: $(OUT)/vm-fuzzer_seed_corpus.zip
 	mkdir -p SEED
 	unzip -o -d SEED $<
@@ -264,14 +260,14 @@
 
 .PHONY: fuzz-regtest
 fuzz-regtest: $(OUT)/vm-fuzzer SEED
-	$(OUT)/vm-fuzzer $(wildcard SEED/*.mtail)
+	$(OUT)/vm-fuzzer -rss_limit_mb=4096 $(shell ls SEED/*.mtail)
 
 CRASH ?=
 
 .PHONY: fuzz-repro
 fuzz-repro: $(OUT)/vm-fuzzer mtail
 	$(OUT)/vm-fuzzer $(CRASH) || true  # Want to continue
-	./mtail --logtostderr --vmodule=checker=2,types=2 --mtailDebug=3 --dump_ast_types --dump_bytecode --compile_only --progs $(CRASH)
+	./mtail --logtostderr --vmodule=loader=2,checker=2,types=2 --mtailDebug=3 --dump_ast_types --dump_bytecode --compile_only --progs $(CRASH)
 
 # make fuzz-min CRASH=example crash
 .PHONY: fuzz-min
@@ -302,7 +298,7 @@
 coverage: coverprofile
 
 coverprofile: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
-	go test -v -covermode=count -coverprofile=$@ -tags=integration -timeout=${timeout} $(PACKAGES)
+	go test -v -covermode=count -coverprofile=$@ -timeout=${timeout} $(PACKAGES)
 
 coverage.html: coverprofile | print-version
 	go tool cover -html=$< -o $@
@@ -310,36 +306,19 @@
 covrep: coverage.html
 	xdg-open $<
 
-ifeq ($(CIRRUS_CI),true)
-  COVERALLS_SERVICE := cirrus-ci
-endif
-ifeq ($(CIRCLECI),true)
-  COVERALLS_SERVICE := circle-ci
-endif
-ifeq ($(TRAVIS),true)
-  COVERALLS_SERVICE := travis-ci
-endif
-
-.PHONY: upload_to_coveralls
-upload_to_coveralls: | coverprofile $(GOVERALLS)
-	$(GOVERALLS) -coverprofile=coverprofile -service=$(COVERALLS_SERVICE)
-
-
-###
-## CircleCI development targets
-#
-
-.PHONY: circleci-validate
-circleci-validate: .circleci/config.yml
-	circleci config validate
-
-# Override this on the make command to say which job to run
-CIRCLEJOB ?= fuzzing
-.PHONY: circleci-execute
-.INTERMEDIATE: tmpconfig.yml
-circleci-execute: .circleci/config.yml circleci-validate
-ifeq ($(CIRCLECI),true)
-	$(error "Don't run this target from within CircleCI!")
-endif
-	circleci config process $< > tmpconfig.yml
-	circleci local execute -c tmpconfig.yml --job $(CIRCLEJOB)
+###
+## Github issue tracking
+#
+GHI = $(GOBIN)/ghi
+$(GHI):
+	go get $(GOGETFLAGS) github.com/markbates/ghi
+
+issue-fetch: | $(GHI)
+	$(GHI) fetch
+
+issue-list: | $(GHI)
+	$(GHI) list
+
+ISSUE?=1
+issue-show: | $(GHI)
+	$(GHI) show $(ISSUE)
