=== debian/changelog ===
mtail (3.0.0~rc38-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Refresh patches.

 -- Filippo Giunchedi <filippo@debian.org>  Fri, 27 Nov 2020 15:55:48 +0100
