## mtail 3.0.0~rc41

=== debian/changelog ===
mtail (3.0.0~rc41-1) unstable; urgency=medium

  * New upstream release.
    + fix racy/flaky pipe tests (Closes: #976403, #979142)
  * Refresh patches.

 -- Filippo Giunchedi <filippo@debian.org>  Sat, 16 Jan 2021 17:41:57 +0100

mtail (3.0.0~rc38-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.

 -- Filippo Giunchedi <filippo@debian.org>  Tue, 01 Dec 2020 16:53:23 +0100
