## mtail 3.0.0~rc43

=== Makefile ===
--- 
+++ 
@@ -1,9 +1,14 @@
 # Copyright 2011 Google Inc. All Rights Reserved.
 # This file is available under the Apache license.
 
-export GO111MODULE ?= auto
+export GO111MODULE ?= on
 # Build these.
 TARGETS = mtail mgen mdot mfmt
+
+GO_TEST_FLAGS ?= 
+BENCH_COUNT ?= 1
+BASE_REF ?= master
+HEAD_REF ?= $(shell git symbolic-ref HEAD -q --short | tr / - 2>/dev/null)
 
 all: $(TARGETS)
 
@@ -27,9 +32,9 @@
 -include $(patsubst %,$(DEPDIR)/%.d,$(TARGETS))
 
 # Set the timeout for tests run under the race detector.
+timeout := 120s
+ifeq ($(CI),true)
 timeout := 10m
-ifeq ($(CI),true)
-timeout := 20m
 endif
 # Let the benchmarks run for a long time.  The timeout is for the total time of
 # all benchmarks, not per bench.
@@ -57,6 +62,7 @@
 
 # A place to install tool dependencies.
 GOBIN ?= $(firstword $(subst :, ,$(GOPATH)))/bin
+export PATH := $(GOBIN):$(PATH)
 
 TOGO = $(GOBIN)/togo
 $(TOGO):
@@ -74,20 +80,16 @@
 $(GOFUZZ):
 	go get $(GOGETFLAGS) github.com/dvyukov/go-fuzz/go-fuzz
 
-GOVERALLS = $(GOBIN)/goveralls
-$(GOVERALLS):
-	go get $(GOGETFLAGS) github.com/mattn/goveralls
-
-GOX = $(GOBIN)/gox
-$(GOX):
-	go get github.com/mitchellh/gox
-
 GOTESTSUM = $(GOBIN)/gotestsum
 $(GOTESTSUM):
-	go get gotest.tools/gotestsum
-
-
-.PHONY: clean covclean crossclean depclean
+	go get $(GOGETFLAGS) gotest.tools/gotestsum
+
+BENCHSTAT = $(GOBIN)/benchstat
+$(BENCHSTAT):
+	go get $(GOGETFLAGS) golang.org/x/perf/cmd/benchstat
+
+
+.PHONY: clean covclean crossclean depclean veryclean
 clean: covclean crossclean
 	rm -f $(CLEANFILES)
 covclean:
@@ -96,6 +98,7 @@
 	rm -rf build
 depclean:
 	rm -f .d/*  .*dep-stamp
+veryclean: clean depclean
 
 .PHONY: lint
 lint:
@@ -116,6 +119,7 @@
 export CGO_ENABLED=0
 endif
 
+# Show all errors, not just limit to 10.
 GO_GCFLAGS = -e
 
 # Very specific static pattern rule to only do this for commandline targets.
@@ -134,7 +138,7 @@
 	/usr/bin/convert $< -define icon:auto-resize=64,48,32,16 $@ || touch $@
 
 internal/mtail/logo.ico.go: | internal/mtail/logo.ico $(TOGO)
-	$(TOGO) -pkg mtail -name logoFavicon -input internal/mtail/logo.ico
+	togo -pkg mtail -name logoFavicon -input internal/mtail/logo.ico
 
 
 ###
@@ -157,62 +161,49 @@
 	install -d $(@D)
 	install -m 755 $< $@
 
-
-GOX_OSARCH ?= "linux/amd64 windows/amd64 darwin/amd64 linux/arm linux/arm64 linux/ppc64"
-#GOX_OSARCH := ""
-
-.PHONY: crossbuild
-crossbuild: $(GOFILES) $(GOGENFILES) | $(GOX) .dep-stamp print-version
-	mkdir -p build
-	gox --output="./build/mtail_${release}_{{.OS}}_{{.Arch}}" -osarch=$(GOX_OSARCH) -ldflags "$(GO_LDFLAGS)" ./cmd/mtail
-
 .PHONY: test check
 check test: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
-	go test -gcflags "$(GO_GCFLAGS)" -timeout 10s ./...
+	go test $(GO_TEST_FLAGS) -gcflags "$(GO_GCFLAGS)" -timeout 10s ./...
 
 .PHONY: testrace
 testrace: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
-	go test -gcflags "$(GO_GCFLAGS)" -timeout ${timeout} -race -v ./...
+	go test $(GO_TEST_FLAGS) -gcflags "$(GO_GCFLAGS)" -timeout ${timeout} -race -v ./...
 
 .PHONY: smoke
-smoke: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
-	go test -gcflags "$(GO_GCFLAGS)" -timeout 1s -test.short ./...
-
-.PHONY: bench
-bench: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
-	go test -gcflags "$(GO_GCFLAGS)" -bench=. -timeout=${benchtimeout} -benchtime=5s -run=BenchmarkProgram ./...
-
-.PHONY: bench_cpu
-bench_cpu: | print-version .dep-stamp
-	go test -bench=. -run=BenchmarkProgram -timeout=${benchtimeout} -benchtime=5s -cpuprofile=cpu.out internal/mtail/examples_integration_test.go
-.PHONY: bench_mem
-bench_mem: | print-version .dep-stamp
-	go test -bench=. -run=BenchmarkProgram -timeout=${benchtimeout} -benchtime=5s -memprofile=mem.out internal/mtail/examples_integration_test.go
-
-.PHONY: recbench
-recbench: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
-	go test -bench=. -run=XXX --record_benchmark ./...
+smoke: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
+	go test $(GO_TEST_FLAGS) -gcflags "$(GO_GCFLAGS)" -timeout 1s -test.short ./...
 
 .PHONY: regtest
-regtest: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
-	go test -gcflags "$(GO_GCFLAGS)" -v -timeout=${timeout} ./...
+regtest: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
+	go test $(GO_TEST_FLAGS) -gcflags "$(GO_GCFLAGS)" -v -timeout=${timeout} ./...
 
 TESTRESULTS ?= test-results
 TESTCOVERPROFILE ?= out.coverprofile
 
 .PHONY: junit-regtest
 junit-regtest: $(TESTRESULTS)/test-output.xml $(TESTCOVERPROFILE)
+
 $(TESTRESULTS)/test-output.xml $(TESTCOVERPROFILE): $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp $(GOTESTSUM)
 	mkdir -p $(TESTRESULTS)
-	$(GOTESTSUM) --junitfile $(TESTRESULTS)/test-output.xml -- -race -parallel 1 -coverprofile=$(TESTCOVERPROFILE) --covermode=atomic -v -timeout=${timeout} -gcflags "$(GO_GCFLAGS)" ./...
+	gotestsum --debug --junitfile $(TESTRESULTS)/test-output.xml -- $(GO_TEST_FLAGS) -cpu 1,2,4 -race -parallel 1 -coverprofile=$(TESTCOVERPROFILE) --covermode=atomic -v -timeout=${timeout} -gcflags "$(GO_GCFLAGS)" ./...
+
+.PHONY: bench
+bench: $(TESTRESULTS)/benchmark-results-$(HEAD_REF).txt
+
+$(TESTRESULTS)/benchmark-results-$(HEAD_REF).txt: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
+	mkdir -p $(TESTRESULTS)
+	go test -cpu 1,2,4 -bench=. -count=$(BENCH_COUNT) -timeout=${benchtimeout} -run=^a ./... | tee $@
+
+.PHONY: benchstat
+benchstat: $(TESTRESULTS)/benchstat.txt
+$(TESTRESULTS)/benchstat.txt: $(TESTRESULTS)/benchmark-results-$(HEAD_REF).txt | print-version $(BENCHSTAT)
+	(test -s $(TESTRESULTS)/benchmark-results-$(BASE_REF).txt && benchstat $(TESTRESULTS)/benchmark-results-$(BASE_REF).txt $< || benchstat $<) | tee $@
+
 
 PACKAGES := $(shell go list -f '{{.Dir}}' ./... | grep -v /vendor/ | grep -v /cmd/ | sed -e "s@$$(pwd)@.@")
 
 .PHONY: testall
 testall: testrace bench regtest
-
-IMPORTS := $(shell go list -f '{{join .Imports "\n"}}' ./... | sort | uniq | grep -v mtail)
-TESTIMPORTS := $(shell go list -f '{{join .TestImports "\n"}}' ./... | sort | uniq | grep -v mtail)
 
 ## make u a container
 .PHONY: container
@@ -239,7 +230,7 @@
 OUT ?= .
 
 $(OUT)/vm-fuzzer: $(GOFILES) | $(GOFUZZBUILD)
-	$(GOFUZZBUILD) -o fuzzer.a ./internal/vm
+	go114-fuzz-build -o fuzzer.a ./internal/vm
 	$(CXX) $(CXXFLAGS) $(LIB_FUZZING_ENGINE) fuzzer.a -lpthread -o $(OUT)/vm-fuzzer
 
 $(OUT)/vm-fuzzer.dict: mgen
@@ -280,13 +271,7 @@
 .PHONY: install_deps
 install_deps: .dep-stamp
 .dep-stamp: | $(GOGENFILES) print-version
-	@echo "Install all dependencies, ensuring they're updated"
-ifeq ($(GO111MODULE),on)
-	go get $(GOGETFLAGS) -t ./...
-else
-	go get $(GOGETFLAGS) $(IMPORTS)
-	go get $(GOGETFLAGS) $(TESTIMPORTS)
-endif
+	go mod download
 	touch $@
 
 
@@ -314,11 +299,11 @@
 	go get $(GOGETFLAGS) github.com/markbates/ghi
 
 issue-fetch: | $(GHI)
-	$(GHI) fetch
+	ghi fetch
 
 issue-list: | $(GHI)
-	$(GHI) list
+	ghi list
 
 ISSUE?=1
 issue-show: | $(GHI)
-	$(GHI) show $(ISSUE)
+	ghi show $(ISSUE)
