=== debian/changelog ===
mtail (3.0.0~rc43-4) unstable; urgency=medium

  * Update init script, service unit, and defaults.
    This fixes bugs and updates the init script to properly support globs in
    the LOGS configuration variable, drop the `daemon` dependency, and other
    improvements made by Guillem Jover to pkg-prometheus init scripts.
    It also updates the systemd service file to reach feature-parity with the
    SysV init script, and the default file to document all available options.
  * Update to compat 13.
  * Update Standards-Version with no changes.
  * Update watchfile.

 -- Martina Ferrari <tina@debian.org>  Fri, 10 Dec 2021 11:37:08 +0000

mtail (3.0.0~rc43-3) unstable; urgency=medium

  * Mute spammy log messages when reading from named pipes.
    See also https://github.com/google/mtail/issues/462

 -- Filippo Giunchedi <filippo@debian.org>  Sun, 23 May 2021 20:56:53 +0200

mtail (3.0.0~rc43-2) unstable; urgency=medium

  * Use MemorySwapMax=0 with cgroups v2 / systemd unified hierarchy
    (Closes: #985354)

 -- Filippo Giunchedi <filippo@debian.org>  Tue, 16 Mar 2021 21:11:14 +0100

mtail (3.0.0~rc43-1) unstable; urgency=medium

  * New upstream release.

 -- Filippo Giunchedi <filippo@debian.org>  Thu, 21 Jan 2021 15:19:11 +0100
