=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: mtail
 Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
-Uploaders: Martín Ferrari <tincho@debian.org>,
+Uploaders: Martina Ferrari <tina@debian.org>,
 Section: net
 Testsuite: autopkgtest-pkg-go
 Priority: optional
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 13),
                dh-golang (>= 1.17~),
                golang-any,
                golang-github-fsnotify-fsnotify-dev,
@@ -16,7 +16,8 @@
                golang-go.opencensus-dev,
                golang-golang-x-tools,
                tzdata,
-Standards-Version: 4.3.0
+Standards-Version: 4.6.0.1
+Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/go-team/packages/mtail
 Vcs-Git: https://salsa.debian.org/go-team/packages/mtail.git
 Homepage: https://github.com/google/mtail/
@@ -25,7 +26,6 @@
 Package: mtail
 Architecture: any
 Depends: adduser,
-         daemon,
          tzdata,
          ${misc:Depends},
          ${shlibs:Depends},
