=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

#export DH_VERBOSE=1
export DH_GOPKG := github.com/google/mtail
export DH_GOLANG_EXCLUDES := $(DH_GOPKG)/cmd/mgen $(DH_GOPKG)/cmd/mdot
export DH_GOLANG_INSTALL_EXTRA := examples/ \
    internal/mtail/golden/ internal/mtail/testdata/ \
    internal/vm/parser/parser.y
# Build parser.go
export DH_GOLANG_GO_GENERATE := 1

BUILDDIR := $(CURDIR)/build
BUILDFLAGS = -ldflags \
  " -X main.Version=$(DEB_VERSION_UPSTREAM)\
    -X main.Revision=$(DEB_VERSION)"

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=$(BUILDDIR)

override_dh_auto_build:
	dh_auto_build -- $(BUILDFLAGS)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifeq ($(DEB_HOST_ARCH_BITS),64)
	dh_auto_test
else
	# soft fail on non 64-bit architectures:
	# https://github.com/google/mtail/issues/313
	dh_auto_test || echo "W: ignoring known test failure on 32-bit architectures"
endif
	# Only run race tests on amd64.
	test "$(DEB_HOST_ARCH_CPU)" != amd64 || \
            GOCACHE=$(BUILDDIR) GO111MODULE=off GOPROXY=off GOPATH=$(BUILDDIR) go test -v -timeout 5m -race -tags=integration \
                $(DH_GOPKG)/...
endif

override_dh_installinit:
	dh_installinit --no-enable --no-start

override_dh_installsystemd:
	dh_installsystemd --no-enable --no-start

override_dh_auto_install:
	dh_auto_install -- --no-source
