## mtail 3.0.0~rc48

=== Makefile ===
--- 
+++ 
@@ -5,10 +5,12 @@
 # Build these.
 TARGETS = mtail mgen mdot mfmt
 
-GO_TEST_FLAGS ?= 
+GO_TEST_FLAGS ?=
 BENCH_COUNT ?= 1
-BASE_REF ?= master
-HEAD_REF ?= $(shell git symbolic-ref HEAD -q --short | tr / - 2>/dev/null)
+BASE_REF ?= main
+HEAD_REF ?= $(shell git symbolic-ref HEAD -q --short)
+BASE_REF := $(subst /,-,$(BASE_REF))
+HEAD_REF := $(subst /,-,$(HEAD_REF))
 
 all: $(TARGETS)
 
@@ -38,55 +40,57 @@
 endif
 # Let the benchmarks run for a long time.  The timeout is for the total time of
 # all benchmarks, not per bench.
-benchtimeout := 20m
-
-# Be verbose with `go get`, if UPDATE is y then also update dependencies.
-GOGETFLAGS = -v
-ifeq ($(UPDATE),y)
-GOGETFLAGS += -u
-endif
+benchtimeout := 120m
 
 GOFILES=$(shell find . -name '*.go' -a ! -name '*_test.go')
 
 GOTESTFILES=$(shell find . -name '*_test.go')
 
-GOGENFILES=internal/vm/parser/parser.go\
+GOGENFILES=internal/runtime/compiler/parser/parser.go\
 	internal/mtail/logo.ico.go
 
 
 CLEANFILES+=\
-	internal/vm/parser/parser.go\
-	internal/vm/parser/y.output\
+	internal/runtime/compiler/parser/parser.go\
+	internal/runtime/compiler/parser/y.output\
 	internal/mtail/logo.ico.go\
 	internal/mtail/logo.ico\
 
 # A place to install tool dependencies.
-GOBIN ?= $(firstword $(subst :, ,$(GOPATH)))/bin
+GOBIN ?= $(firstword $(subst :, ,$(shell go env GOPATH)))/bin
 export PATH := $(GOBIN):$(PATH)
 
 TOGO = $(GOBIN)/togo
 $(TOGO):
-	go get $(GOGETFLAGS) github.com/flazz/togo
+	go install github.com/flazz/togo@latest
 
 GOYACC = $(GOBIN)/goyacc
 $(GOYACC):
-	go get $(GOGETFLAGS) golang.org/x/tools/cmd/goyacc
+	go install golang.org/x/tools/cmd/goyacc@latest
 
 GOFUZZBUILD = $(GOBIN)/go114-fuzz-build
 $(GOFUZZBUILD):
-	go get $(GOGETFLAGS) github.com/mdempsky/go114-fuzz-build
+	go install github.com/mdempsky/go114-fuzz-build@latest
 
 GOFUZZ = $(GOBIN)/go-fuzz
 $(GOFUZZ):
-	go get $(GOGETFLAGS) github.com/dvyukov/go-fuzz/go-fuzz
+	go install github.com/dvyukov/go-fuzz/go-fuzz@latest
 
 GOTESTSUM = $(GOBIN)/gotestsum
 $(GOTESTSUM):
-	go get $(GOGETFLAGS) gotest.tools/gotestsum
+	go install gotest.tools/gotestsum@latest
 
 BENCHSTAT = $(GOBIN)/benchstat
 $(BENCHSTAT):
-	go get $(GOGETFLAGS) golang.org/x/perf/cmd/benchstat
+	go install golang.org/x/perf/cmd/benchstat@latest
+
+GOSEC = $(GOBIN)/gosec
+$(GOSEC):
+	go install github.com/securego/gosec/v2/cmd/gosec@latest
+
+GOLANGCILINT = $(GOBIN)/golangci-lint
+$(GOLANGCILINT):
+	go install github.com/golangci/golangci-lint/cmd/golangci-lint@latest
 
 
 .PHONY: clean covclean crossclean depclean veryclean
@@ -100,9 +104,10 @@
 	rm -f .d/*  .*dep-stamp
 veryclean: clean depclean
 
+# lint
 .PHONY: lint
-lint:
-	golangci-lint run ./...
+lint:  $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | $(GOLANGCILINT)
+	$(GOLANGCILINT) run ./...
 
 branch := $(shell git rev-parse --abbrev-ref HEAD)
 version := $(shell git describe --tags --always --dirty)
@@ -131,7 +136,7 @@
 	$(MAKEDEPEND)
 	go build -gcflags "$(GO_GCFLAGS)" -ldflags "$(GO_LDFLAGS)" -o $@ $<
 
-internal/vm/parser/parser.go: internal/vm/parser/parser.y | $(GOYACC)
+internal/runtime/compiler/parser/parser.go: internal/runtime/compiler/parser/parser.y | $(GOYACC)
 	go generate -x ./$(@D)
 
 internal/mtail/logo.ico: logo.png
@@ -146,7 +151,9 @@
 #
 .PHONY: print-version
 print-version:
-	@go version
+	which go
+	go version
+	go env
 
 ###
 ## Install rules
@@ -185,11 +192,10 @@
 
 $(TESTRESULTS)/test-output.xml $(TESTCOVERPROFILE): $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp $(GOTESTSUM)
 	mkdir -p $(TESTRESULTS)
-	gotestsum --debug --junitfile $(TESTRESULTS)/test-output.xml -- $(GO_TEST_FLAGS) -cpu 1,2,4 -race -parallel 1 -coverprofile=$(TESTCOVERPROFILE) --covermode=atomic -v -timeout=${timeout} -gcflags "$(GO_GCFLAGS)" ./...
+	gotestsum --debug --junitfile $(TESTRESULTS)/test-output.xml -- $(GO_TEST_FLAGS) -p=1 -cpu=1,2,4 -race -count=1 -parallel=1 -coverprofile=$(TESTCOVERPROFILE) --covermode=atomic -v -timeout=30m -gcflags "$(GO_GCFLAGS)" ./...
 
 .PHONY: bench
 bench: $(TESTRESULTS)/benchmark-results-$(HEAD_REF).txt
-
 $(TESTRESULTS)/benchmark-results-$(HEAD_REF).txt: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
 	mkdir -p $(TESTRESULTS)
 	go test -cpu 1,2,4 -bench=. -count=$(BENCH_COUNT) -timeout=${benchtimeout} -run=^a ./... | tee $@
@@ -197,13 +203,16 @@
 .PHONY: benchstat
 benchstat: $(TESTRESULTS)/benchstat.txt
 $(TESTRESULTS)/benchstat.txt: $(TESTRESULTS)/benchmark-results-$(HEAD_REF).txt | print-version $(BENCHSTAT)
-	(test -s $(TESTRESULTS)/benchmark-results-$(BASE_REF).txt && benchstat $(TESTRESULTS)/benchmark-results-$(BASE_REF).txt $< || benchstat $<) | tee $@
+	(test -s $(TESTRESULTS)/benchmark-results-$(BASE_REF).txt && benchstat -sort=-delta $(TESTRESULTS)/benchmark-results-$(BASE_REF).txt $< || benchstat $<) | tee $@
 
 
 PACKAGES := $(shell go list -f '{{.Dir}}' ./... | grep -v /vendor/ | grep -v /cmd/ | sed -e "s@$$(pwd)@.@")
 
 .PHONY: testall
-testall: testrace bench regtest
+testall: testrace fuzz-regtest bench
+
+.PHONY: checkall
+checkall: check all fuzz-targets
 
 ## make u a container
 .PHONY: container
@@ -214,30 +223,36 @@
 	    --build-arg build_date=$(shell date -Iseconds --utc) \
 	    .
 
-# Append the bin subdirs of every element of the GOPATH list to PATH, so we can find goyacc.
-empty :=
-space := $(empty) $(empty)
-export PATH := $(PATH):$(subst $(space),:,$(patsubst %,%/bin,$(subst :, ,$(GOPATH))))
+## Run gosec
+.PHONY: gosec
+gosec: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | $(GOSEC)
+	$(GOSEC) -tags fuzz ./...
+
 
 ###
 ## Fuzz testing
 #
 
 # These flags set compatibility with OSS-Fuzz
-CXX ?= clang-9
-CXXFLAGS ?=
-LIB_FUZZING_ENGINE ?= -fsanitize=fuzzer
+CXX = clang
+CXXFLAGS ?= -fsanitize=fuzzer,address
+LIB_FUZZING_ENGINE ?=
 OUT ?= .
 
+.PHONY: fuzz-targets
+fuzz-targets: $(OUT)/vm-fuzzer
+
 $(OUT)/vm-fuzzer: $(GOFILES) | $(GOFUZZBUILD)
-	go114-fuzz-build -o fuzzer.a ./internal/vm
+	go114-fuzz-build -o fuzzer.a ./internal/runtime
 	$(CXX) $(CXXFLAGS) $(LIB_FUZZING_ENGINE) fuzzer.a -lpthread -o $(OUT)/vm-fuzzer
 
 $(OUT)/vm-fuzzer.dict: mgen
 	./mgen --dictionary | sort > $@
 
-$(OUT)/vm-fuzzer_seed_corpus.zip: $(wildcard examples/*.mtail) $(wildcard internal/vm/fuzz/*.mtail)
+$(OUT)/vm-fuzzer_seed_corpus.zip: $(wildcard examples/*.mtail) $(wildcard internal/runtime/fuzz/*.mtail)
 	zip -j $@ $^
+
+FUZZER_FLAGS=-rss_limit_mb=4096 -timeout=60s
 
 .INTERMEDIATE: SEED/*
 SEED: $(OUT)/vm-fuzzer_seed_corpus.zip
@@ -247,18 +262,18 @@
 .PHONY: fuzz
 fuzz: SEED $(OUT)/vm-fuzzer $(OUT)/vm-fuzzer.dict
 	mkdir -p CORPUS
-	$(OUT)/vm-fuzzer -dict=$(OUT)/vm-fuzzer.dict CORPUS SEED
+	$(OUT)/vm-fuzzer $(FUZZER_FLAGS) -dict=$(OUT)/vm-fuzzer.dict CORPUS SEED
 
 .PHONY: fuzz-regtest
 fuzz-regtest: $(OUT)/vm-fuzzer SEED
-	$(OUT)/vm-fuzzer -rss_limit_mb=4096 $(shell ls SEED/*.mtail)
+	$(OUT)/vm-fuzzer $(FUZZER_FLAGS) $(shell ls SEED/*.mtail)
 
 CRASH ?=
 
 .PHONY: fuzz-repro
 fuzz-repro: $(OUT)/vm-fuzzer mtail
-	$(OUT)/vm-fuzzer $(CRASH) || true  # Want to continue
-	./mtail --logtostderr --vmodule=loader=2,checker=2,types=2 --mtailDebug=3 --dump_ast_types --dump_bytecode --compile_only --progs $(CRASH)
+	$(OUT)/vm-fuzzer $(FUZZER_FLAGS) $(CRASH) || true  # Want to continue
+	./mtail --logtostderr --vmodule=runtime=2,lexer=2,parser=2,checker=2,types=2,codegen=2 --mtailDebug=3 --dump_ast --dump_ast_types --dump_bytecode --compile_only --progs $(CRASH)
 
 # make fuzz-min CRASH=example crash
 .PHONY: fuzz-min
@@ -270,7 +285,7 @@
 #
 .PHONY: install_deps
 install_deps: .dep-stamp
-.dep-stamp: | $(GOGENFILES) print-version
+.dep-stamp: | print-version $(GOGENFILES)
 	go mod download
 	touch $@
 
@@ -296,7 +311,7 @@
 #
 GHI = $(GOBIN)/ghi
 $(GHI):
-	go get $(GOGETFLAGS) github.com/markbates/ghi
+	go install github.com/markbates/ghi@latest
 
 issue-fetch: | $(GHI)
 	ghi fetch
