=== debian/changelog ===
mtail (3.0.0~rc48-1) unstable; urgency=medium

  * New upstream release.
  * When using gccgo, ensure the right version is used.
  * Add distribution info as Branch variable.
  * debian/rules: Add missing make snippet, default to full tests.
  * debian/rules: set tests timeout.
  * debian/rules: use dh_auto_test for race tests too.
  * Refresh patches, removing unneeded patch.
  * debian/rules: update paths of extra files.
  * debian/rules: Increase test timeouts.

 -- Martina Ferrari <tina@debian.org>  Wed, 29 Dec 2021 00:42:59 +0000
