=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
 Build-Depends: debhelper-compat (= 13),
                dh-golang (>= 1.17~),
                golang-any,
+               golang-go (>= 2:1.14~) | gccgo (>= 4:10~),
                golang-github-fsnotify-fsnotify-dev,
                golang-github-golang-groupcache-dev,
                golang-github-google-go-cmp-dev,
