=== debian/changelog ===
mtail (3.0.0~rc49-1) unstable; urgency=medium

  * New upstream release.
  * Refresh and remove patches already applied upstream.

 -- Martina Ferrari <tina@debian.org>  Wed, 25 May 2022 18:16:47 +0000

mtail (3.0.0~rc48-4) unstable; urgency=medium

  * debian/service: avoid shell glob expansion.
  * debian/service: Use correct path for test.

 -- Martina Ferrari <tina@debian.org>  Wed, 30 Mar 2022 14:39:07 +0000

mtail (3.0.0~rc48-3) unstable; urgency=medium

  * Backport fixes sent upstream.
  * debian/copyright: update years.

 -- Martina Ferrari <tina@debian.org>  Mon, 03 Jan 2022 21:55:04 +0000

mtail (3.0.0~rc48-2) unstable; urgency=medium

  * Increase test timeouts.
    Back-port https://github.com/google/mtail/pull/612 and modify debian/rules
    reflecting the updated timeouts.
  * Stop ignoring test failures in 32-bit arches.
    Since this problem was apparently only present in golang 1.14, increase the
    dependency version and remove the test failure exception.
  * debian/copyright: update years.

 -- Martina Ferrari <tina@debian.org>  Fri, 31 Dec 2021 21:33:38 +0000
