## mtail 3.0.0~rc50

=== debian/changelog ===
mtail (3.0.0~rc50-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.
  * Automatic fixes from cme: remove outdated versioned
    dependencies, conflicts with packages no longer in debian, update
    Standards-Version (no changes), and other automated changes.
  * Add versioned dependency on client-golang.
  * Move golang versioned dependency to golang-any, and update it to 1.17.
  * Remove now unneeded patch.

 -- Martina Ferrari <tina@debian.org>  Thu, 08 Sep 2022 20:49:42 +0000

mtail (3.0.0~rc50-1) unstable; urgency=medium

  * New upstream release.
  * Add patch to fix build errors in go 1.18. Closes: #1017291

 -- Martina Ferrari <tina@debian.org>  Tue, 23 Aug 2022 14:42:45 +0000

mtail (3.0.0~rc48-3~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.
  * Add patch to avoid depending on newer client-golang.

 -- Martina Ferrari <tina@debian.org>  Mon, 03 Jan 2022 22:07:35 +0000

mtail (3.0.0~rc43-4~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Martina Ferrari <tina@debian.org>  Wed, 15 Dec 2021 09:37:10 +0000
