=== debian/control ===
--- 
+++ 
@@ -5,23 +5,22 @@
 Testsuite: autopkgtest-pkg-go
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               dh-golang (>= 1.17~),
-               golang-any,
-               golang-go (>= 2:1.14~) | gccgo (>= 4:10~),
+               dh-golang,
+               golang-any (>= 2:1.17~),
                golang-github-fsnotify-fsnotify-dev,
                golang-github-golang-groupcache-dev,
                golang-github-google-go-cmp-dev,
                golang-github-pkg-errors-dev,
-               golang-github-prometheus-client-golang-dev,
+               golang-github-prometheus-client-golang-dev (>= 1.11~),
                golang-glog-dev,
                golang-go.opencensus-dev,
                golang-golang-x-tools,
                tzdata,
-Standards-Version: 4.6.0.1
-Rules-Requires-Root: no
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/go-team/packages/mtail
 Vcs-Git: https://salsa.debian.org/go-team/packages/mtail.git
 Homepage: https://github.com/google/mtail/
+Rules-Requires-Root: no
 XS-Go-Import-Path: github.com/google/mtail
 
 Package: mtail
@@ -30,7 +29,6 @@
          tzdata,
          ${misc:Depends},
          ${shlibs:Depends},
-Conflicts: monkeytail,
 Built-Using: ${misc:Built-Using},
 Description: Extract monitoring data from logs for collection in a timeseries database
  Mtail is a tool for extracting metrics from application logs to be exported
